Index: trunk/src/lib/network/message_manager.cc
===================================================================
--- trunk/src/lib/network/message_manager.cc	(revision 9391)
+++ trunk/src/lib/network/message_manager.cc	(revision 9406)
@@ -20,6 +20,8 @@
 #include "network_stream.h"
 #include "shared_network_data.h"
-
-using namespace std;
+#include "converter.h"
+#include <cassert>
+
+
 
 MessageManager* MessageManager::singletonRef = NULL;
@@ -52,13 +54,13 @@
       }
     }
-    
+
     it->second.messages.clear();
     it->second.toAck.clear();
   }
-  
+
   messageQueue.clear();
-  
+
   this->messageHandlerMap.clear();
-  
+
   MessageManager::singletonRef = NULL;
 }
@@ -82,9 +84,9 @@
   int i = 0;
   int n;
-  
+
   n = Converter::intToByteArray( messageQueue[userId].toAck.size(), data + i, maxLength );
   i += n;
   assert( n == INTSIZE );
-  
+
   for ( std::list<int>::iterator it = messageQueue[userId].toAck.begin(); it != messageQueue[userId].toAck.end(); it++)
   {
@@ -93,11 +95,11 @@
     assert( n == INTSIZE );
   }
-  
+
   messageQueue[userId].toAck.clear();
-  
+
   n = Converter::intToByteArray( messageQueue[userId].messages.size(), data + i, maxLength );
   i += n;
   assert( n == INTSIZE );
-  
+
   for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end(); it++ )
   {
@@ -105,18 +107,18 @@
     i += n;
     assert( n == INTSIZE );
-    
+
     n = Converter::intToByteArray( it->number, data + i, maxLength );
     i += n;
     assert( n == INTSIZE );
-    
+
     n = Converter::intToByteArray( it->messageId, data + i, maxLength );
     i += n;
     assert( n == INTSIZE );
-    
+
     assert( i + it->length <= maxLength );
     memcpy( data + i, it->data, it->length );
     i += it->length;
   }
-  
+
   return i;
 }
@@ -136,16 +138,16 @@
   int i = 0;
   int n;
-  
+
   int nAcks;
-  
+
   assert( i + INTSIZE <= length );
   n = Converter::byteArrayToInt( data + i, &nAcks );
   assert( n == INTSIZE );
   i += n;
-  
+
   std::list<int> acks;
-  
+
   int number;
-  
+
   for ( int j = 0; j < nAcks; j++ )
   {
@@ -154,10 +156,10 @@
     assert( n == INTSIZE );
     i += n;
-    
+
     acks.push_back( number );
   }
-  
+
   int nMessages;
-  
+
   assert( i + INTSIZE <= length );
   n = Converter::byteArrayToInt( data + i, &nMessages );
@@ -166,5 +168,5 @@
 
   int messageLength, messageId;
-  
+
   for ( int j = 0; j < nMessages; j++ )
   {
@@ -173,18 +175,18 @@
     assert( n == INTSIZE );
     i += n;
-    
+
     assert( i + INTSIZE <= length );
     n = Converter::byteArrayToInt( data + i, &number );
     assert( n == INTSIZE );
     i += n;
-  
+
     assert( i + INTSIZE <= length );
     n = Converter::byteArrayToInt( data + i, &messageId );
     assert( n == INTSIZE );
     i += n;
-    
+
     if ( number > 0 )
       messageQueue[userId].toAck.push_back( number );
-    
+
     assert( i + messageLength <= length );
     assert( messageHandlerMap.find( (MessageId)messageId ) != messageHandlerMap.end() );
@@ -194,5 +196,5 @@
       {
         NetworkMessage msg;
-        
+
         msg.data = new byte[messageLength];
         memcpy( msg.data, data + i, messageLength );
@@ -200,5 +202,5 @@
         msg.messageId = (MessageId)messageId;
         msg.number = userId;
-        
+
         incomingMessageBuffer.push_back( msg );
       }
@@ -207,6 +209,6 @@
     i += messageLength;
   }
-  
-  
+
+
   //TODO maybe handle incomingMessage in tick function. else local messages will not be handled if no clients are connected
   for ( std::list<NetworkMessage>::iterator it = incomingMessageBuffer.begin(); it != incomingMessageBuffer.end();  )
@@ -223,5 +225,5 @@
     it++;
   }
-  
+
   //walk throu message queue and remove acked messages
   for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end();  )
@@ -236,5 +238,5 @@
     it++;
   }
-  
+
   //TODO find bether way. maybe with timestamp
   if ( messageQueue[userId].recievedMessages.size() > 1000 )
@@ -255,5 +257,5 @@
   if ( messageQueue.find( userId ) == messageQueue.end() )
     return;
-    
+
   for ( std::list<NetworkMessage>::iterator it = messageQueue[userId].messages.begin(); it != messageQueue[userId].messages.end(); it++ )
   {
@@ -262,7 +264,7 @@
     it->data = NULL;
   }
-  
+
   messageQueue[userId].toAck.clear();
-  
+
   messageQueue.erase( userId );
 }
@@ -270,5 +272,5 @@
 /**
  * registers function to handle messages with id messageId. someData is passed to callbackfuntion
- * @param messageId message id to handle 
+ * @param messageId message id to handle
  * @param cb function pointer to callback function
  * @param someData this pointer is passed to callback function without modification
@@ -278,11 +280,11 @@
 {
   MessageHandler messageHandler;
-  
+
   messageHandler.cb = cb;
   messageHandler.messageId = messageId;
   messageHandler.someData = someData;
-  
+
   messageHandlerMap[messageId] = messageHandler;
-  
+
   return true;
 }
@@ -309,6 +311,6 @@
  * @param data pointer to data
  * @param dataLength length of data
- * @param recieverType 
- * @param reciever 
+ * @param recieverType
+ * @param reciever
  */
 void MessageManager::sendMessage( MessageId messageId, byte * data, int dataLength, RecieverType recieverType, int reciever, MessagePriority messagePriority )
@@ -316,10 +318,10 @@
   for ( MessageQueue::iterator it = messageQueue.begin(); it != messageQueue.end(); it++ )
   {
-    if ( 
+    if (
          recieverType == RT_ALL_ME ||
          recieverType == RT_ALL_NOT_ME ||
          recieverType == RT_USER && it->first == reciever ||
          recieverType == RT_NOT_USER && it->first != reciever ||
-         recieverType == RT_SERVER && getNetworkStream()->isUserServer( it->first )
+         recieverType == RT_SERVER && getNetworkStream()->isUserMasterServer( it->first )
        )
     {
@@ -336,5 +338,5 @@
     }
   }
-  
+
   if ( recieverType == RT_ALL_ME )
   {
Index: trunk/src/lib/network/monitor/connection_monitor.cc
===================================================================
--- trunk/src/lib/network/monitor/connection_monitor.cc	(revision 9406)
+++ trunk/src/lib/network/monitor/connection_monitor.cc	(revision 9406)
@@ -0,0 +1,257 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+#include "connection_monitor.h"
+#include "network_log.h"
+
+#include <debug.h>
+#include <SDL/SDL.h>
+#include <string.h>
+
+/* using namespace std is default, this needs to be here */
+
+
+/**
+ * constructor
+ * @param userId user's id
+ */
+ConnectionMonitor::ConnectionMonitor( int userId )
+{
+  /* set the class id for the base object and add ist to class list*/
+  this->setClassID(CL_CONNECTION_MONITOR, "ConnectionMonitor");
+  
+  this->userId = userId;
+  this->ping = 0;
+  this->incomingUnzippedBandWidth = 0;
+  this->outgoingUnzippedBandWidth = 0;
+  this->incomingZippedBandWidth = 0;
+  this->outgoingZippedBandWidth = 0;
+  this->nIncomingPackets = 0;
+  this->nOutgoingPackets = 0;
+  this->nZIncomingPackets = 0;
+  this->nZOutgoingPackets = 0;
+  
+  this->lastPacketTick = 0;
+  this->lastPrintTick = 0;
+}
+
+/**
+ * deconstructor
+ */
+ConnectionMonitor::~ConnectionMonitor( )
+{
+}
+
+/**
+ * process unzipped outgoing packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ */
+void ConnectionMonitor::processUnzippedOutgoingPacket( int tick, byte * data, int length, int stateId )
+{
+  nOutgoingPackets++;
+  
+  // for ping calculation
+  sentStateTicks[stateId] = tick;
+  
+  // calculate bandwidth
+  outgoingUnzippedPacketHistory[tick] = length;
+  outgoingUnzippedBandWidth = calculateBandWidth( outgoingUnzippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UNZIPPED UPSTREAM: user: %d bandwidth %f\n", userId, outgoingUnzippedBandWidth );
+  
+  // count zero bytes
+  //int nZeroBytes = 0;
+  
+  //for ( int i = 0; i < length; i++ )
+  //  if ( data[i] == '\0' )
+  //    nZeroBytes++;
+  
+  //NETPRINTF(n)( "ZEROBYTES: %d (%f%%)\n", nZeroBytes, ((float)100)*nZeroBytes/length );
+}
+
+/**
+ * process unzipped incoming packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ * @param ackedState state which was acked by this packet
+ */
+void ConnectionMonitor::processUnzippedIncomingPacket( int tick, byte * data, int length, int stateId, int ackedState )
+{
+  nIncomingPackets++;
+  
+  lastPacketTick = tick;
+  
+  // calculate ping
+  if ( sentStateTicks.find( ackedState ) != sentStateTicks.end() )
+  {
+    ackDelay.push_back( tick - sentStateTicks[ackedState] );
+  }
+  
+  while ( sentStateTicks.begin() != sentStateTicks.end() && sentStateTicks.begin()->first <= ackedState )
+    sentStateTicks.erase( sentStateTicks.begin() );
+      
+  while ( ackDelay.size() > N_PACKETS_FOR_PING )
+    ackDelay.erase( ackDelay.begin() );
+      
+  ping = 0;
+      
+  for ( std::list<int>::iterator it = ackDelay.begin(); it != ackDelay.end(); it++ )
+    ping += *it;
+      
+  if ( ackDelay.size() == 0 )
+    ping = -1;
+  else
+    ping /= ackDelay.size();
+      
+  //NETPRINTF(n)("PING: user: %d ping: %d\n", userId, ping );
+  
+  // calculate bandwidth
+  incomingUnzippedPacketHistory[tick] = length;
+  incomingUnzippedBandWidth = calculateBandWidth( incomingUnzippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UNZIPPED DOWNSTREAM: user: %d bandwidth %f\n", userId, incomingUnzippedBandWidth );
+  
+}
+
+/**
+ * remove old packets
+ * @param packetHistory 
+ * @param tick 
+ */
+void ConnectionMonitor::removeOldPackets( std::map< int, int > & packetHistory, int tick )
+{
+  while ( packetHistory.begin()->first < tick - MSECS_TO_CALC_BWIDTH )
+    packetHistory.erase( packetHistory.begin() );
+}
+
+/**
+ * calculate bandwidth out of packethistory
+ * @param packetHistory packet history
+ * @param tick current tick from SDL_GetTicks
+ * @return bandwidth in bytes/sec
+ */
+float ConnectionMonitor::calculateBandWidth( std::map< int, int > & packetHistory, int tick )
+{
+  removeOldPackets( packetHistory, tick );
+  
+  float res = 0.0f;
+#if 0
+  for ( std::map<int,int>::iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
+  {
+    if ( it != packetHistory.begin() )
+      res += it->second;
+  }
+  
+  if ( packetHistory.size() <= 1 || tick - packetHistory.begin()->first == 0 )
+    res = 0.0f;
+  else
+    res /= (float)(tick - packetHistory.begin()->first);
+  
+  res *= 1000.0f;
+#endif
+
+  for ( std::map<int,int>::iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
+  {
+    res += it->second;
+  }
+  
+  if ( packetHistory.size() <= 1 )
+    res = 0.0f;
+  else
+    res /= (float)(tick - packetHistory.begin()->first);
+  
+  res *= 1000.0f;
+
+  return res;
+}
+
+
+/**
+ * process zipped outgoing packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ */
+void ConnectionMonitor::processZippedOutgoingPacket( int tick, byte * data, int length, int stateId )
+{
+  nZOutgoingPackets++;
+  
+  // calculate bandwidth
+  outgoingZippedPacketHistory[tick] = length;
+  outgoingZippedBandWidth = calculateBandWidth( outgoingZippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UPSTREAM: user: %d bandwidth %f nOutgoingPackets %d\n", userId, outgoingZippedBandWidth, nOutgoingPackets );
+
+  if ( lastPrintTick < tick-1000 )
+  {
+    printStatis();
+    lastPrintTick = tick;
+  }
+}
+
+
+/**
+ * process zipped incoming packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ * @param ackedState state which was acked by this packet
+ */
+void ConnectionMonitor::processZippedIncomingPacket( int tick, byte * data, int length )
+{
+  nZIncomingPackets++;
+  
+  // calculate bandwidth
+  incomingZippedPacketHistory[tick] = length;
+  incomingZippedBandWidth = calculateBandWidth( incomingZippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("DOWNSTREAM: user: %d bandwidth %f nIncomingPackets %d\n", userId, incomingZippedBandWidth, nIncomingPackets );
+  
+}
+
+
+/**
+ * check if client sent no packets for SECS_TO_TIMEOUT
+ * @return true if last packet recieved \< NOW() - SECS_TO_TIMEOUT
+ */
+bool ConnectionMonitor::hasTimedOut( )
+{
+  if ( lastPacketTick + SECS_TO_TIMEOUT*1000 < SDL_GetTicks() && nIncomingPackets > 0 )
+    return true;
+  
+  if ( nIncomingPackets == 0 && nOutgoingPackets >= NETWORK_FREQUENCY*SECS_TO_TIMEOUT )
+    return true;
+  
+  return false;
+}
+
+
+
+/**
+ * prints bandwith usage, ping and other important things to telnet-console
+ */
+void ConnectionMonitor::printStatis( )
+{
+  NETPRINT(n)("============NETWORKSTATS FOR USER %d============\n", userId);
+  NETPRINT(n)("PING = %d\n", ping );
+  NETPRINT(n)("BANDWIDTH: UP: %f (%f) DOWN %f (%f)\n", outgoingZippedBandWidth, outgoingUnzippedBandWidth, incomingZippedBandWidth, incomingUnzippedBandWidth);
+  NETPRINT(n)("PACKETS: RECIEVED %d; SENT %d\n", nIncomingPackets, nOutgoingPackets );
+  NETPRINT(n)("================================================\n");
+}
+
+
Index: trunk/src/lib/network/monitor/connection_monitor.h
===================================================================
--- trunk/src/lib/network/monitor/connection_monitor.h	(revision 9406)
+++ trunk/src/lib/network/monitor/connection_monitor.h	(revision 9406)
@@ -0,0 +1,71 @@
+/*!
+ * @file connection_monitor.h
+    \brief provides information about the quality of a connection.
+ */
+
+#ifndef _CONNECTION_MONITOR_H
+#define _CONNECTION_MONITOR_H
+
+#include "base_object.h"
+#include "netdefs.h"
+
+#include <map>
+#include <list>
+
+#define N_PACKETS_FOR_PING 20
+#define MSECS_TO_CALC_BWIDTH 1000
+#define SECS_TO_TIMEOUT 30
+
+class ConnectionMonitor : virtual public BaseObject
+{
+  public:
+    ConnectionMonitor( int userId );
+    virtual ~ConnectionMonitor();
+
+    void processUnzippedOutgoingPacket( int tick, byte * data, int length, int stateId );
+    void processUnzippedIncomingPacket( int tick, byte * data, int length, int stateId, int ackedState );
+
+    void processZippedOutgoingPacket( int tick, byte * data, int length, int stateId );
+    void processZippedIncomingPacket( int tick, byte * data, int length );
+
+    void calculatePing();
+
+    bool hasTimedOut();
+
+    void printStatis();
+
+  private:
+    float calculateBandWidth( std::map<int,int> & packetHistory, int tick );
+    void removeOldPackets( std::map<int,int> & packetHistory, int tick );
+
+    int userId;       //!< user's id
+
+    std::map<int,int>   sentStateTicks;
+
+    std::map<int,int>   incomingUnzippedPacketHistory;
+    std::map<int,int>   outgoingUnzippedPacketHistory;
+
+    std::map<int,int>   incomingZippedPacketHistory;
+    std::map<int,int>   outgoingZippedPacketHistory;
+
+    std::list<int>      ackDelay;
+    int                 ping;
+
+    float               incomingUnzippedBandWidth;
+    float               outgoingUnzippedBandWidth;
+
+    float               incomingZippedBandWidth;
+    float               outgoingZippedBandWidth;
+
+    int                 nIncomingPackets;
+    int                 nOutgoingPackets;
+
+    int                 nZIncomingPackets;
+    int                 nZOutgoingPackets;
+
+    int                 lastPacketTick;
+
+    int                 lastPrintTick;
+  };
+
+#endif
Index: trunk/src/lib/network/monitor/network_monitor.cc
===================================================================
--- trunk/src/lib/network/monitor/network_monitor.cc	(revision 9406)
+++ trunk/src/lib/network/monitor/network_monitor.cc	(revision 9406)
@@ -0,0 +1,272 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#include "glgui.h"
+#include "shell_command.h"
+
+#include "network_stream.h"
+#include "debug.h"
+
+#include "proxy/network_settings.h"
+#include "shared_network_data.h"
+
+#include "network_monitor.h"
+#include "network_node.h"
+#include "peer_info.h"
+#include "network_stream.h"
+#include "netdefs.h"
+
+#include <vector>
+
+
+SHELL_COMMAND(showGUI, NetworkMonitor, showGUI);
+SHELL_COMMAND(hideGUI, NetworkMonitor, hideGUI);
+SHELL_COMMAND(debug, NetworkMonitor, debug);
+
+
+
+/**
+ * starts a network monitor
+ */
+NetworkMonitor::NetworkMonitor(NetworkStream* networkStream)
+  : Synchronizeable()
+{
+  this->setClassID(CL_NETWORK_MONITOR, "NetworkMonitor");
+
+  this->networkStream = networkStream;
+  this->playerNumber = 0;
+  // create the localnode, init it and add it to the nodes list
+  this->localNode = new NetworkNode( this->networkStream->getPeerInfo());
+  this->addNode(this->localNode);
+
+  this->setSynchronized(false);
+
+  // read in the proxy server list, this is only the case for the master server
+  if( SharedNetworkData::getInstance()->isMasterServer())
+  {
+    // assuming that the config files are already read we get the proxy servers
+    std::vector<IPaddress*>* proxyList = NetworkSettings::getInstance()->getProxyList();
+    std::vector<IPaddress*>::iterator it = proxyList->begin();
+    // create a peer info class and a network node class for each new proxy and add them to the passive list
+    for(; it < proxyList->end(); it++)
+    {
+      PeerInfo* peer = new PeerInfo();
+      peer->ip = *(*it);
+      peer->nodeType = NET_PROXY_SERVER_ACTIVE;
+      peer->userId = -1;
+
+      NetworkNode* node = new NetworkNode(peer);
+      this->addNode( node);
+      this->addActiveProxyServer( this->localNode, peer);
+    }
+  }
+}
+
+
+/**
+ * deconstructor
+ */
+NetworkMonitor::~NetworkMonitor()
+{
+  if( this->localNode)
+    delete this->localNode;
+}
+
+
+/**
+ * add the network node
+ * @param node to add
+ */
+void NetworkMonitor::addNetworkNode(NetworkNode* node)
+{
+  this->nodeList.push_back(node);
+}
+
+
+/**
+ * add the network node
+ * @param node to add
+ */
+void NetworkMonitor::removeNetworkNode(NetworkNode* node)
+{
+  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  for(; it != this->nodeList.end(); it++)
+  {
+    if( *it == node)
+    {
+      if( node->getNodeType() == NET_CLIENT)
+        this->playerNumber--;
+
+      this->nodeList.erase(it);
+      return;
+    }
+  }
+}
+
+/**
+ * tihs adds the new network node
+ * @param ip ip of the new node
+ */
+void NetworkMonitor::addNode(IP ip, int nodeType)
+{
+  PeerInfo* pInfo = new PeerInfo();
+  pInfo->nodeType = nodeType;
+  pInfo->ip = ip;
+
+  this->addNode( pInfo);
+}
+
+
+/**
+ * adds a network node to the local node
+ *  @param pInfo node information
+ */
+void NetworkMonitor::addNode(PeerInfo* pInfo)
+{
+  if( this->localNode == NULL)
+    return;
+
+  if( pInfo->isClient())
+    this->localNode->addClient(pInfo);
+  else if( pInfo->isProxyServer())
+  {
+    this->localNode->addActiveProxyServer(pInfo);
+    // create a new node, since a proxy can connect clients again
+    NetworkNode* node = new NetworkNode(pInfo);
+    this->nodeList.push_back(node);
+  }
+  else if( pInfo->isMasterServer())
+  {
+    this->localNode->addMasterServer(pInfo);
+  }
+}
+
+
+/**
+ * adds a network node to the local node
+ *  @param node node to add to
+ *  @param pInfo node information
+ */
+void NetworkMonitor::addNode(NetworkNode* node, PeerInfo* pInfo)
+{
+  if( node == NULL)
+    return;
+
+  if( pInfo->isClient())
+    node->addClient(pInfo);
+  else if( pInfo->isProxyServer())
+    node->addActiveProxyServer(pInfo);
+  else if( pInfo->isMasterServer())
+    node->addMasterServer(pInfo);
+}
+
+
+/**
+ * @returns the proxy server of the first choice
+ */
+PeerInfo* NetworkMonitor::getFirstChoiceProxy()
+{
+  // return the fist proxy in the list
+  return this->localNode->getActiveProxyServer(0);
+}
+
+
+/**
+ * @returns the proxy server of second choice
+ */
+PeerInfo* NetworkMonitor::getSecondChoiceProxy()
+{
+  // return the second server in the list
+  return this->localNode->getActiveProxyServer(1);
+}
+
+
+/**
+ * this displays the network monitor gui
+ */
+void NetworkMonitor::showGUI()
+{
+  if (this->box == NULL)
+  {
+    this->box = new OrxGui::GLGuiBox(OrxGui::Vertical);
+    {
+      OrxGui::GLGuiBox* waterColorBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
+      {
+        OrxGui::GLGuiText* waterColorText = new OrxGui::GLGuiText();
+        waterColorText->setText("NetworkMonitor");
+        waterColorBox->pack(waterColorText);
+      }
+      this->box->pack(waterColorBox);
+    }
+
+    this->box->showAll();
+    this->box->setAbsCoor2D(300, 40);
+    OrxGui::GLGuiHandler::getInstance()->activate();
+//     OrxGui::GLGuiHandler::getInstance()->activateCursor();
+  }
+}
+
+
+/**
+ * hides the network monitor gui again
+ */
+void NetworkMonitor::hideGUI()
+{
+  if( this->box == NULL)
+    return;
+
+  OrxGui::GLGuiHandler::getInstance()->deactivate();
+//   OrxGui::GLGuiHandler::getInstance()->deactivateCursor();
+
+  delete this->box;
+  this->box = NULL;
+}
+
+
+/**
+ * processes the network monitor data
+ */
+void NetworkMonitor::process()
+{
+  this->playerNumber = 0;
+  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  for(; it != this->nodeList.end(); it++)
+  {
+    this->playerNumber += (*it)->getPlayerNumber();
+  }
+
+  // check if a proxy server has to activated
+
+//   this->debug();
+}
+
+/**
+ * prints out the debug informations
+ */
+void NetworkMonitor::debug()
+{
+  PRINT(0)("================================= Network Monitor::debug() =====\n");
+  PRINT(0)(" I am: %s\n", this->localNode->getPeerInfo()->getNodeTypeString().c_str());
+  PRINT(0)(" Total count of network connections: %i\n", this->playerNumber);
+  PRINT(0)(" Max players on this server: %i\n", SharedNetworkData::getInstance()->getMaxPlayer());
+
+  std::list<NetworkNode*>::iterator it = this->nodeList.begin();
+  for(; it != this->nodeList.end(); it++)
+  {
+    (*it)->debug(0);
+  }
+
+  PRINT(0)("================================================================\n");
+}
+
Index: trunk/src/lib/network/monitor/network_monitor.h
===================================================================
--- trunk/src/lib/network/monitor/network_monitor.h	(revision 9406)
+++ trunk/src/lib/network/monitor/network_monitor.h	(revision 9406)
@@ -0,0 +1,95 @@
+/*!
+ * @file network_monitor.h
+ *  a class to monitor the network: throughput, network nodes
+ */
+
+#ifndef _NETWORK_MONITOR_H
+#define _NETWORK_MONITOR_H
+
+#include "base_object.h"
+#include "synchronizeable.h"
+#include "shared_network_data.h"
+#include "ip.h"
+
+#include "network_node.h"
+
+#include <list>
+
+class NetworkStream;
+class PeerInfo;
+
+
+namespace OrxGui { class GLGuiBox; };
+
+
+
+//!< a class that monitors the whole network. it tries to gather all informations its able to from the network
+class NetworkMonitor : public Synchronizeable
+{
+
+  public:
+    NetworkMonitor(NetworkStream* networkStream);
+    virtual ~NetworkMonitor();
+
+    /* client/masterserver/proxyserver addition/removal interface */
+    void addNetworkNode(NetworkNode* node);
+    void removeNetworkNode(NetworkNode* node);
+
+    void addNode(PeerInfo* pInfo);
+    void addNode(IP ip, int nodeType);
+    void addNode(NetworkNode* node) { this->nodeList.push_back(node); }
+    void addNode(NetworkNode* node, PeerInfo* pInfo);
+
+    /** adds to @param node a network node @param pInfo a new client */
+    inline void addClient(NetworkNode* node, PeerInfo* pInfo) { node->addClient(pInfo); }
+    /** adds to @param node a network node @param pInfo a new proxy server */
+    inline void addActiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->addActiveProxyServer(pInfo); }
+    /** adds to @param node a network node @param pInfo a new proxy server */
+    inline void addPassiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->addPassiveProxyServer(pInfo); }
+    /** adds to @param node a network node @param pInfo a new master server*/
+    inline void addMasterServer(NetworkNode* node, PeerInfo* pInfo) { node->addMasterServer(pInfo); }
+
+    inline void removeClient(NetworkNode* node, PeerInfo* pInfo) { node->removeClient(pInfo); }
+    inline void removeActiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->removeActiveProxyServer(pInfo); }
+    inline void removePassiveProxyServer(NetworkNode* node, PeerInfo* pInfo) { node->removePassiveProxyServer(pInfo); }
+    inline void removeMasterServer(NetworkNode* node, PeerInfo* pInfo) { node->removeMasterServer(pInfo); }
+
+    PeerInfo* getFirstChoiceProxy();
+    PeerInfo* getSecondChoiceProxy();
+
+    /** @returns the active proxy server list of the localnode */
+    inline std::list<PeerInfo*> getActiveProxyServer() { return this->localNode->getActiveProxyServer(); }
+
+    /* slots admin and info interface */
+    /** @returns the total number of players in this game (including all proxy servers etc)*/
+    inline int getPlayerNumber() { return this->playerNumber; }
+
+    /** @returns true if there are still free network slots available at the local node*/
+    inline bool gotFreeSlots() { return (this->localNode->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+    /** @param node node to be checked for slots @returns true if there are still free network slots available at this node */
+    inline bool gotFreeSlots(NetworkNode* node) { return (node->getPlayerNumber() < SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+
+    /** @returns true if the next client should be reconnected to some other proxy server with more connections */
+    inline bool isReconnectNextClient() { return (this->localNode->getPlayerNumber() >= SharedNetworkData::getInstance()->getMaxPlayer())?true:false; }
+
+
+    void showGUI();
+    void hideGUI();
+
+    void process();
+    void debug();
+
+
+  private:
+    NetworkStream*               networkStream;              //!< reference to the one networkstream of the network
+    NetworkNode*                 localNode;                  //!< reference to the local node
+    std::list<NetworkNode*>      nodeList;                   //!< list of all network nodes
+
+    OrxGui::GLGuiBox*            box;
+
+    int                          playerNumber;                 //!< total number of players in the game
+    int                          connectionNumber;             //!< total number of connections at this localhost
+};
+
+
+#endif
